<?php

namespace Drupal\rater8_testimonial_block\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a dynamic block with configurable Rater8 ID.
 *
 * @Block(
 *   id = "rater8_testimonial_block",
 *   admin_label = @Translation("Rater8 Testimonials"),
 *   category = @Translation("Custom Block"),
 * )
 */
class Rater8TestimonialBlock extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [
      'id' => '',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function blockForm($form, FormStateInterface $form_state) {
    $form['id'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Rater8 ID'),
      '#default_value' => $this->configuration['id'],
      '#required' => TRUE,
      '#size' => 25,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function blockSubmit($form, FormStateInterface $form_state) {
    $this->configuration['id'] = $form_state->getValue('id');
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    $id = $this->configuration['id'];

    if (!empty($id)) {
      $markup = $this->t('
        <div id="rater8Testimonials" style="background:#fff;"></div>
        <script>
        var s1 = document.createElement("script"), s0 = document.getElementsByTagName("script")[0];
        s1.src = "https://reviews.rater8.com/scripts/bluebird.min.js";
        s0.parentNode.insertBefore(s1, s0);

        var s3 = document.createElement("script"), s2 = document.getElementsByTagName("script")[1];
        s3.src = "https://reviews.rater8.com/scripts/fetch.umd.js";
        s2.parentNode.insertBefore(s3, s2);

        function showTestimonials(physicianId, locationId, format) {
          fetch("https://reviews.rater8.com/webwidget/api/testimonials/' . $id . '?format=" + format)
            .then(function(response) {
              response.text()
                .then(function(snippet) {
                  var div = document.getElementById(locationId);
                  div.innerHTML = snippet;
                  var arr = div.getElementsByTagName("script");
                  for (var n = 0; n < arr.length; n++) eval(arr[n].innerHTML);
                });
            });
        }
        showTestimonials("' . $id . '", "rater8Testimonials", "htmlComments");
        </script>
      ');

      return [
        '#markup' => $markup,
      ];
    }

    return [];
  }

}
